"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var useQuery_1 = require("../useQuery");
var context_1 = require("../context");
var EMPTY_ARRAY = [];
function Connect(props) {
    var ctx = context_1.useContext();
    var client = ctx.client;
    var previousElementRef = React.useRef(null);
    var r = useQuery_1.default(props.query);
    if (r.errored && props.renderErrors !== true) {
        if (props.renderErrors === false) {
            return null;
        }
        else if (typeof props.renderErrors === 'function') {
            return (React.createElement(React.Fragment, null, props.renderErrors(r.errors, client, {
                result: r.result,
                loaded: false,
                errors: r.errors,
                errorDetails: r.errorDetails,
                previousElement: previousElementRef.current,
                loadingDuration: 0,
            })));
        }
        else {
            return r.render();
        }
    }
    if (r.loading && props.renderLoading !== true) {
        if (props.renderLoading === false) {
            return null;
        }
        else if (typeof props.renderLoading === 'function') {
            return (React.createElement(React.Fragment, null, props.renderLoading(r.loadingDuration, client, {
                result: r.result,
                loaded: false,
                errors: EMPTY_ARRAY,
                errorDetails: EMPTY_ARRAY,
                previousElement: previousElementRef.current,
                loadingDuration: r.loadingDuration,
            })));
        }
        else {
            return r.render();
        }
    }
    var result = props.children(r.result, client, {
        result: r.result,
        loaded: r.loaded,
        errors: r.errored ? r.errors : EMPTY_ARRAY,
        errorDetails: r.errored ? r.errorDetails : EMPTY_ARRAY,
        previousElement: previousElementRef.current,
        loadingDuration: r.loading ? r.loadingDuration : 0,
    });
    previousElementRef.current = result;
    return React.createElement(React.Fragment, null, result);
}
exports.default = Connect;
function query(query, children, options) {
    var C = Connect;
    return React.createElement(C, __assign({ query: query,
        children: children }, options));
}
exports.query = query;
//# sourceMappingURL=Connect.js.map