"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Connect_1 = require("./Connect");
var useClient_1 = require("../useClient");
var hoistStatics = require('hoist-non-react-statics');
function getConnectResultProps(status) {
    return {
        result: status.result,
        loaded: status.loaded,
        errors: status.errors,
        errorDetails: status.errorDetails,
        previousElement: status.previousElement,
    };
}
var EMPTY_OBJECT = {};
function connect(WrappedComponent, getQuery, getEventHandlers, options) {
    if (options === void 0) { options = EMPTY_OBJECT; }
    function ConnectWrapper(props) {
        var client = useClient_1.default();
        var eventHandlers = {};
        if (getEventHandlers) {
            eventHandlers = getEventHandlers(client, props);
        }
        if (!getQuery) {
            return React.createElement(WrappedComponent, __assign({}, props, eventHandlers));
        }
        var renderLoading = options.renderLoading, renderErrors = options.renderErrors;
        return (React.createElement(Connect_1.default, { query: getQuery(props), renderLoading: typeof renderLoading === 'boolean'
                ? renderLoading
                : renderLoading &&
                    (function (_duration, _client, status) {
                        return React.createElement(renderLoading, __assign({}, props, eventHandlers, getConnectResultProps(status)));
                    }), renderErrors: typeof renderErrors === 'boolean'
                ? renderErrors
                : renderErrors &&
                    (function (_result, _client, status) {
                        return React.createElement(renderErrors, __assign({}, props, eventHandlers, getConnectResultProps(status)));
                    }) }, function (_results, _client, status) { return (React.createElement(WrappedComponent, __assign({}, props, eventHandlers, getConnectResultProps(status)))); }));
    }
    return hoistStatics(ConnectWrapper, WrappedComponent);
}
exports.default = connect;
//# sourceMappingURL=connect-hoc.js.map